/*****************************************************************************
 * misc-utils                                                                *
 *****************************************************************************/

/*****************************************************************************
 * File name:     block64.h                                                  *
 * Created:       2002-08-24 by Hampa Hug <hhug@student.ethz.ch>             *
 * Last modified: 2002-08-27 by Hampa Hug <hhug@student.ethz.ch>             *
 * Copyright:     (C) 2002 by Hampa Hug <hhug@student.ethz.ch>               *
 *****************************************************************************/

/*****************************************************************************
 * This program is free software. You can redistribute it and / or modify it *
 * under the terms of the GNU General Public License version 2 as  published *
 * by  the Free Software Foundation.                                         *
 *                                                                           *
 * This program is distributed in the hope  that  it  will  be  useful,  but *
 * WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
 * Public License for more details.                                          *
 *****************************************************************************/

/* $Id: block64.h 384 2005-12-29 11:30:57Z hampa $ */


#ifndef MISC_BLOCK64_H
#define MISC_BLOCK64_H 1


/*!***************************************************************************
 * @short A 64 bit block
 *****************************************************************************/
typedef struct {
	unsigned long word32[2];
} block64_t;


/*****************************************************************************
 * @short Initialize a block to all zeros.
 *****************************************************************************/
void blk64_init (block64_t *blk);

/*****************************************************************************
 * @short Read a block from a byte buffer.
 *****************************************************************************/
void blk64_get_buf (block64_t *blk, const unsigned char buf[8]);

/*****************************************************************************
 * @short Write a block to a byte buffer.
 *****************************************************************************/
void blk64_set_buf (const block64_t *blk, unsigned char buf[8]);

void blk64_set_32 (block64_t *blk, unsigned i, unsigned long val);

void blk64_set_8 (block64_t *blk, unsigned i, unsigned char val);

void blk64_xor (block64_t *dst, const block64_t *src);


#endif
