/*****************************************************************************
 * misc-utils                                                                *
 *****************************************************************************/

/*****************************************************************************
 * File name:     src/ecc/ecc.h                                              *
 * Created:       2003-06-20 by Hampa Hug <hampa@hampa.ch>                   *
 * Copyright:     (C) 2003-2008 Hampa Hug <hampa@hampa.ch>                   *
 *****************************************************************************/

/*****************************************************************************
 * This program is free software. You can redistribute it and / or modify it *
 * under the terms of the GNU General Public License version 2 as  published *
 * by  the Free Software Foundation.                                         *
 *                                                                           *
 * This program is distributed in the hope  that  it  will  be  useful,  but *
 * WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
 * Public License for more details.                                          *
 *****************************************************************************/

/* $Id: ecc.h 487 2008-08-12 13:18:01Z hampa $ */


#define ECC_MAGIC 0x45434320UL

#define ECC_CODE_NONE    0
#define ECC_CODE_HAMMING 1


typedef struct {
	unsigned      n;
	unsigned      d;
	unsigned long bytes;
	unsigned char **buf;
} buffer_t;


typedef struct {
	unsigned long magic;
	unsigned long vers;
	unsigned long size;
	unsigned long code;
	unsigned      n;
	unsigned      k;
	unsigned long d;
} ecc_header_t;


typedef struct {
	unsigned long code;

	unsigned      n;
	unsigned      k;
	unsigned      d;

	unsigned char *tmpdat;
	unsigned char *tmpecc1;
	unsigned char *tmpecc2;

	buffer_t      *bufdat;
	buffer_t      *bufecc;
} ecc_t;
