/*****************************************************************************
 * misc-utils                                                                *
 *****************************************************************************/

/*****************************************************************************
 * File name:     socket.h                                                   *
 * Created:       2002-01-20 by Hampa Hug <hampa@hampa.ch>                   *
 * Last modified: 2003-01-17 by Hampa Hug <hampa@hampa.ch>                   *
 * Copyright:     (C) 2002-2003 Hampa Hug <hampa@hampa.ch>                   *
 *****************************************************************************/

/*****************************************************************************
 * This program is free software. You can redistribute it and / or modify it *
 * under the terms of the GNU General Public License version 2 as  published *
 * by  the Free Software Foundation.                                         *
 *                                                                           *
 * This program is distributed in the hope  that  it  will  be  useful,  but *
 * WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
 * Public License for more details.                                          *
 *****************************************************************************/

/* $Id: socket.h 335 2005-04-22 02:05:56Z hampa $ */


#ifndef MISC_SOCKET_H
#define MISC_SOCKET_H 1


int tcp_connect (const char *host, unsigned short port);
int tcp_listen (const char *host, unsigned short port, unsigned queue);
int tcp_accept (int fd);
int tcp_accept_time (int fd, int t);

void tcp_shutdown (int fd);
void tcp_shutdown_out (int fd);
void tcp_shutdown_inp (int fd);

int tcp_get_peer (int fd, char **host, unsigned short *port);
int tcp_get_host (int fd, char **host, unsigned short *port);

char *tcp_addr_get_host (const char *str);
int tcp_addr_get_port (const char *str, unsigned short *port);
char *tcp_host_resolve (const char *str);


#endif
